unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    TimeFlash: TTimer;
    EditClassName: TEdit;
    EditWindowText: TEdit;
    Image1: TImage;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Splitter1: TSplitter;
    TreeClassName: TTreeView;
    RichClassText: TRichEdit;
    TabSheet2: TTabSheet;
    ScrollBox1: TScrollBox;
    ImgWindow: TImage;
    BitBtn2: TBitBtn;
    TabSheet3: TTabSheet;
    MemModules: TMemo;
    BitBtn3: TBitBtn;
    procedure BitBtn1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure TimeFlashTimer(Sender: TObject);
    procedure TreeClassNameChange(Sender: TObject; Node: TTreeNode);
    procedure BitBtn2Click(Sender: TObject);
    procedure TreeClassNameClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    FInMouseDown: Boolean;
    FPreTopMostWH: HWND;
    FPreWH: HWND;
    procedure UpdateTopMostWH(const WH: HWND);
    procedure UpdateWH(const WH: HWND);
    procedure UpdateWindowText();
    procedure UpdateWindowImage(const WH: HWND);
    procedure EnumChildren(Node: TTreeNode);
    procedure TravelChilden(Node: TTreeNode);
    procedure UpdateWindowModules(const WH: HWND);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    Info, Types, ClipBrd, psapi;

{$R *.dfm}
{$R custom.res}

const
    CUR_SEEKER = 1;
    CURSEEK = 'CR_SEEKER01';

type
  PHWndArray = ^THWndArray;
  THWndArray = array[0..500] of HWND;

//-----------------------------------------------------------------------------
//  w肵nhEBhẺ`悷
procedure FlashDesktopCanvas(const Target: HWND; const Interval: integer);
var
    DesktopDC: HDC;
    RT: TRect;
    WI: TWindowInfo;
    DesktopCanvas: TCanvas;
begin
    //  fXNgbṽfoCXReLXg擾
    DesktopDC := GetDC(0);
    if (DesktopDC <> INVALID_HANDLE_VALUE) then
    begin
        DesktopCanvas := TCanvas.Create;
        try
            //  O
            DesktopCanvas.Handle := DesktopDC;
            DesktopCanvas.Pen.Width := 3;
            DesktopCanvas.Pen.Mode := pmNotXor;
            //  EBhE擾
            if GetWindowInfo(Target, WI) then
            begin
                //  NCAg̈擾
                RT := WI.rcWindow;
                //  fXNgbvɋ``(XOR)
                DesktopCanvas.Rectangle(RT);
                //  ΂҂
                Sleep(Interval);
                //  fXNgbvɋ``(XOR)
                DesktopCanvas.Rectangle(RT);
            end;
        finally
            //  fXNgbṽfoCXReLXgj
            DesktopCanvas.Free;
            ReleaseDC(0, DesktopDC);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  w肵nhEBhEǂꂩĂ݂
procedure FlashDesktopCanvas2(const Target: HWND; const Interval: integer);
var
    CurHandle: HWND;
begin
    CurHandle := GetForegroundWindow();
    //  Oɏo
    if SetForegroundWindow(Target) then
    begin
        //  Ƒ҂(ꂪȂƕ`悪݂)
        Sleep(Interval);
        //  
        FlashDesktopCanvas(Target, Interval);
        //  Ƒ҂
        Sleep(Interval);
    end;
    //  ɖ߂
    SetForegroundWindow(CurHandle);
end;

//-----------------------------------------------------------------------------
//  Cӂ̃EBhEŏʂ̃gbvxEBhE擾
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function GetMostTopLevelWindow(hWindow:HWND):HWND;
var
  hAncestor,hPrev:HWND;
begin
  hPrev := hWindow;
  hAncestor := GetParent(hPrev);
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetParent(hPrev)
  end;
  hAncestor := hPrev;
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetWindow(hPrev,GW_OWNER)
  end;
  result := hPrev;
end;

//-----------------------------------------------------------------------------
//  NX擾
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function GetClassNameStr(hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  GetMem(p,100);
  ret := GetClassName(hWindow,p,100);
  SetString(result,p,ret);
  FreeMem(p);
end;

//-----------------------------------------------------------------------------
//  EBhEeLXg擾
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function GetWindowTextStr(hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  ret := GetWindowTextLength(hWindow);
  GetMem(p,ret+1);
  ret := GetWindowText(hWindow,p,ret+1);
  SetString(result,p,ret);
  FreeMem(p);
end;

//-----------------------------------------------------------------------------
//  ڂ̎qEBhÊݗ񋓂
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function EnumDirectChildren(var WA:THWndArray; hParent:HWND):integer;
var
  hWindow:HWND;
begin
  WA[0] := 0;
  hWindow := GetWindow(hParent,GW_CHILD);
  while (hWindow <> 0) do begin
    WA[0] := WA[0]+1;
    WA[WA[0]] := hWindow;
    hWindow := GetWindow(hWindow,GW_HWNDNEXT);
  end;
  result := WA[0];
end;

//-----------------------------------------------------------------------------
//  EnumThreadWindows() ̃bp[AXbh̃gbvxEBhE̗
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function EnumThreadWndProc(hWindow:HWND;lData:LPARAM):BOOL;stdcall;
var
  pWA:PHWndArray;
begin
  pWA := PHWndArray(lData);
  pWA^[0] := pWA^[0]+1;
  pWA^[pWA^[0]] := hWindow;
  result := true;
end;

//-----------------------------------------------------------------------------
function AEnumThreadWindows(var WA:THWndArray; OneOfHandles:HWND):integer;
begin
  WA[0] := 0;
  EnumThreadWindows(GetWindowThreadProcessId(OneOfHandles,nil),
                      @EnumThreadWndProc,LPARAM(@WA));
  result := WA[0];
end;

//-----------------------------------------------------------------------------
//  ڂ Owned EBhE񋓂
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function EnumDirectOwnedWindows(var WA:THWndArray; hOwner:HWND):integer;
var
  WWA:THWndArray;
  i,Num:integer;
begin
  result := 0;
  Num := AEnumThreadWindows(WWA,hOwner);
  if Num > 0 then
    for i := 1 to Num do
      if GetWindow(WWA[i],GW_OWNER) = hOwner then begin
        Inc(result);
        WA[result] := WWA[i]
      end;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    //  J[\Ǎ
    Screen.Cursors[CUR_SEEKER] := LoadCursor(HInstance, CURSEEK);

    //  Lv`łȂ
    FInMouseDown := False;

    FPreTopMostWH := INVALID_HANDLE_VALUE;
    FPreWH := INVALID_HANDLE_VALUE;
end;

//-----------------------------------------------------------------------------
//  ^[QbgEBhE擾̗Jn
procedure TForm1.BitBtn1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    FInMouseDown := True;
    Screen.Cursor := CUR_SEEKER;
    BitBtn1.Glyph := nil;
    RichClassText.Clear();
    MemModules.Clear();
end;

//-----------------------------------------------------------------------------
//  łHłH
procedure TForm1.TimeFlashTimer(Sender: TObject);
var
    WH: HWND;
begin
    //  XpCłȂ΃XLbv
    if (not FInMouseDown) then Exit;
    //  }EX̃EBhEnho
    WH := WindowFromPoint(Mouse.CursorPos);
    //  tbV
    FlashDesktopCanvas(WH, 100);

    //  \
    UpdateWH(WH);
    UpdateTopMostWH(WH);
end;

//-----------------------------------------------------------------------------
//  ^[QbgEBhE擾̗I
procedure TForm1.BitBtn1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
    WH: HWND;
begin
    //  tO|ăJ[\ɖ߂
    FInMouseDown := False;
    Screen.Cursor := crDefault;
    BitBtn1.Glyph := Image1.Picture.Bitmap;

    //  \
    UpdateWindowText();

    //  }EX̃EBhEnho
    WH := WindowFromPoint(Mouse.CursorPos);
    UpdateWindowImage(WH);
    UpdateWindowModules(WH);
end;

//-----------------------------------------------------------------------------
//  ^[QbgEBhE̍ŏʂ̐eEBhȄ\
procedure TForm1.UpdateTopMostWH(const WH: HWND);
var
    PWH: HWND;
    LName: String;
    LNode: TTreeNode;
begin
    PWH := GetMostTopLevelWindow(WH);
    if (FPreTopMostWH = PWH) then Exit;
    FPreTopMostWH := PWH;

    TreeClassName.Items.Clear;

    if (PWH <> 0) then
    begin
        LName := GetClassNameStr(PWH);
        LNode := TreeClassName.Items.AddObject(nil, LName, Pointer(PWH));
        TreeClassNameChange(nil, LNode);
    end;

    if (TreeClassName.Items.Count > 0) then
    begin
        TreeClassName.TopItem := TreeClassName.Items.Item[0];
    end;
end;

//-----------------------------------------------------------------------------
//  KwđSẴEBhȄ\
procedure TForm1.EnumChildren(Node: TTreeNode);
var
    WA: THWndArray;
    WH: HWND;
    i, Num: integer;
    LNode: TTreeNode;
    LName: String;
    LText: String;
begin
    if (Node.Count > 0) then Exit;

    Num := EnumDirectChildren(WA, HWND(Node.Data));
    if (Num > 0) then
    begin
        for i := 1 to Num do
        begin
            WH := WA[i];
            if IsWindowVisible(WH) then
            begin
                LName := GetClassNameStr(WH);
                LText := GetWindowTextStr(WH);
                LNode := TreeClassName.Items.AddChildObject(Node,
                                                LName + '(' + LText + ')',
                                                Pointer(WH));
                EnumChildren(LNode);
            end;
        end;
    end;

    Num := EnumDirectOwnedWindows(WA, HWND(Node.Data));
    if Num > 0 then
    begin
        for i := 1 to Num do
        begin
            WH := WA[i];
            if IsWindowVisible(WH) then
            begin
                LName := '*' + GetClassNameStr(WH);
                LText := GetWindowTextStr(WH);
                LNode := TreeClassName.Items.AddChildObject(Node,
                                                LName + '(' + LText + ')',
                                                Pointer(WH));
                EnumChildren(LNode);
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.TreeClassNameChange(Sender: TObject; Node: TTreeNode);
begin
    if (Node.Level = 0) and (Node.Count = 0) then
    begin
        EnumChildren(Node);
        Node.Expand(True);
    end;
end;

//-----------------------------------------------------------------------------
//  ^[QbgEBhE\
procedure TForm1.UpdateWH(const WH: HWND);
begin
    if (FPreWH = WH) then Exit;
    FPreWH := WH;

    EditClassName.Text := GetClassNameStr(WH);
    EditWindowText.Text := GetWindowTextStr(WH);
end;

//-----------------------------------------------------------------------------
//  擾EBhẼLvV(ċAp֐)
procedure TForm1.TravelChilden(Node: TTreeNode);
var
    i: Integer;
    WH: HWND;
    LName: String;
    LText: String;
begin
    WH := HWND(Node.Data);
    LName := GetClassNameStr(WH);
    LText := GetWindowTextStr(WH);

    //  NX
    RichClassText.SelAttributes.Color := clRed;
    RichClassText.SelAttributes.Style := [fsBold];
    RichClassText.Lines.Add(LName);

    //  EBhEeLXg
    if (LText <> '') then
    begin
        RichClassText.SelAttributes.Color := clWindowText;
        RichClassText.SelAttributes.Style := [];
        RichClassText.Lines.Add(LText);
    end;

    for i := 0 to Node.Count - 1 do
    begin
        TravelChilden(Node.Item[i]);
    end;
end;

//-----------------------------------------------------------------------------
//  擾EBhẼLvV
procedure TForm1.UpdateWindowText();
begin
    if (TreeClassName.Items.Count > 0) then
    begin
        TravelChilden(TreeClassName.Items.Item[0]);
    end;
end;

//-----------------------------------------------------------------------------
//  ̃EBhẼC[WLv`
procedure TForm1.UpdateWindowImage(const WH: HWND);
var
    DC: HDC;
    WI: TWindowInfo;
    LRectW: TRect;
    LBitmap: TBitmap;
begin
    // foCXReLXg擾
    DC := GetWindowDC(WH);

    // EBhE擾
    GetWindowInfo(WH, WI);

    //  EBhË
    LRectW := WI.rcWindow;

    LBitmap := TBitmap.Create();
    LBitmap.Width := LRectW.Right - LRectW.Left;
    LBitmap.Height := LRectW.Bottom - LRectW.Top;
    BitBlt(LBitmap.Canvas.Handle, 0, 0,
            LBitmap.Width, LBitmap.Height,
            DC, 0, 0, SRCCOPY);
    ImgWindow.Height := LBitmap.Height;
    ImgWindow.Width := LBitmap.Width;
    ImgWindow.Picture.Assign(LBitmap);
    LBitmap.Free();

    // DC̊J
    ReleaseDC(WH, DC);
end;

//-----------------------------------------------------------------------------
//  ̃EBhẼC[WLv`gK[
procedure TForm1.BitBtn2Click(Sender: TObject);
var
    LFormat: Word;
    LData: THandle;
    LPalette: HPalette;
begin
    ImgWindow.Picture.Bitmap.SaveToClipboardFormat(LFormat, LData, LPalette);
    Clipboard.SetAsHandle(LFormat, LData);
end;

//-----------------------------------------------------------------------------
//  c[őIEBhE\
procedure TForm1.TreeClassNameClick(Sender: TObject);
var
    LNode: TTreeNode;
    WH: HWND;
begin
    LNode := TreeClassName.Selected;
    if (LNode <> nil) then
    begin
        WH := HWND(LNode.Data);
        FlashDesktopCanvas2(WH, 200);

        //UpdateWindowImage(WH);
    end;
end;

//-----------------------------------------------------------------------------
//  擾EBhE̎̃W[Ɗ֘A郂W[
//  ms-help://MS.PSDK.1033/perfmon/base/enumerating_all_modules_for_a_process.htm
procedure TForm1.UpdateWindowModules(const WH: HWND);
const
    MAX_HMODULE = 1024;
var
    ProcessID: integer;
    DesiredAccess: Cardinal;                        //  tO
    ModHandle : array[0..MAX_HMODULE-1] of HMODULE; //  W[nh
    ProcHandle: THandle;                            //  vZXnh
    cbNeeded  : DWORD;                              //  z̑傫
    i         : integer;
    p         : PChar;
    ModName   : string;                             //  W[
begin
    //  ̃EBhẼvZXID
    {ThreadID := }GetWindowThreadProcessId(WH, @ProcessID);

    //  vZX̃nho
    DesiredAccess := PROCESS_QUERY_INFORMATION or PROCESS_VM_READ;
    ProcHandle := OpenProcess(DesiredAccess, False, ProcessID);
    //  sH
    if (ProcHandle = INVALID_HANDLE_VALUE) then
    begin
        Exit;
    end
    //  I
    else
    begin
        try
            //  ̃vZX̑SẴW[̃Xg擾(pspi.dll)
            if (EnumProcessModules(ProcHandle, @ModHandle, MAX_HMODULE, cbNeeded)) then
            begin
                //  W[̌JԂ܂傤
                for i := 0 to (cbNeeded div sizeof(HMODULE)) - 1 do
                begin
                    //  m
                    GetMem(p, MAX_PATH);
                    //  W[t@C̃tpX擾
                    GetModuleFileNameEx(ProcHandle, ModHandle[i], p, MAX_PATH);
                    ModName := String(p);
                    //  
                    FreeMem(p);

                    if (i > 0) then
                    begin
                        ModName := '-' + ModName;
                    end;

                    //  Xgɒǉ
                    MemModules.Lines.Add(ModName);
                end;
            end;
        finally
            //  J߂
            CloseHandle(ProcHandle);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  o[W\
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
    OpenInfoForm();
end;

end.
